unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, MapiUnit;

type
  handle = longint;
  pHandle = ^handle;

type
  TForm1 = class(TForm)
    UserName: TEdit;
    Password: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button3: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    Originator: TEdit;
    ReceivedDate: TEdit;
    Subject: TEdit;
    Index: TEdit;
    Label5: TLabel;
    Button5: TButton;
    Memo1: TMemo;
    ListBox2: TListBox;
    Label6: TLabel;
    ListBox3: TListBox;
    Label7: TLabel;
    Button6: TButton;
    Mapi1: TMapi;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
private
    { Private declarations }
  public
    { Public declarations }
 end;
var
  Form1: TForm1;
  Mapi1 : TMapi;

implementation

{$R *.DFM}


 procedure TForm1.Button1Click(Sender: TObject);
var
  logonOK: boolean;
begin
  logonOK := false;
  logonOK := Mapi1.Logon(UserName.text, Password.text);
  if logonOK then
     Label3.caption := 'Successful logon'
  else
     Label3.caption := 'Logon Failure';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  logoffOK: boolean;
begin
  logoffOK := false;
  logoffOK := Mapi1.Logoff;
  if logoffOK then
     Label3.caption := 'Successful logoff'
  else
     Label3.caption := 'Logooff falure';
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  sendOK : boolean;
  temp: pchar;
  MsgOut: TMapiMsg;
  msgText : pchar;
begin
  temp := strAlloc(80);
  MsgOut := TMapiMsg.create(Mapi1.SessionID);
  MsgOut.Subject := 'New Improved Delphi Test Send';
  {msgText := strAlloc(length('This is a test of the Delphi Mapi control send mail function.'));
  strPCopy(msgtext, 'This is a test of the Delphi Mapi control send mail function.');           }
  {or
  msgText := strAlloc(Memo1.GetTextLen+5);
  memo1.GetTextBuf(msgtext, Memo1.GetTextLen);
  MsgOut.MessageText := msgtext;}
  {or}
  MsgOut.MessageTextList.Add('Line 1 message' + #13#10);
  MsgOut.MessageTextList.Add('Line 2 message' + #13#10);
  MsgOut.MessageTextList.Add('Line 3 01234567890123456789012345678901234567890123456789' + #13#10);
  MsgOut.MessageTextList.Add('Line 4 01234567890123456789012345678901234567890123456789' + #13#10);
  MsgOut.MessageTextList.Add('Line 5 01234567890123456789012345678901234567890123456789' + #13#10);
  MsgOut.MessageTextList.Add('Line 6 01234567890123456789012345678901234567890123456789' + #13#10);
  MsgOut.MessageTextList.Add('Line 7 01234567890123456789012345678901234567890123456789' + #13#10);
  MsgOut.MessageTextList.Add('Line 8 01234567890123456789012345678901234567890123456789' + #13#10);
  SendOK := MsgOut.Recipient.Add('Grossman, Stanley', '');
  {if SendOk then
     SendOK := MsgOut.CCRecipient.Add('Smith, John', '');}
  if SendOk then
     sendOK := MsgOut.Send;
  if sendOK then
     Label3.caption := 'Successful Send'
  else
     Label3.caption := 'Send Failure';
end;


procedure TForm1.Button4Click(Sender: TObject);
var
  x : integer;
begin
  for x := 1 to Mapi1.inbox.Count do
     begin
        Mapi1.inbox.SetIndex(x-1);
        ListBox1.items.add(Mapi1.inbox.Subject + ' : ' + Mapi1.inbox.Originator);
     end;

end;

procedure TForm1.Button5Click(Sender: TObject);
var
  OK: boolean;
  myMsg: TMapiMsg;
  buffer: pchar;
  code: integer;
  idx: integer;
  x: integer;
  temp: string;
begin
  myMsg := TMapiMsg.create(Mapi1.SessionID);
  val(index.text, idx, code);
  Mapi1.inbox.SetIndex(idx);
  OK := Mapi1.inbox.OpenEnvelope(myMsg);
  if OK then
     begin
     Originator.text := myMsg.OriginatorName;
     Subject.text := myMsg.Subject;
     ReceivedDate.text := DateTimeToStr(myMsg.ReceivedDate);
     buffer := myMsg.MessageText;
     temp := StrPas(buffer);
     Memo1.SettextBuf(buffer);
     ListBox2.clear;
     for x := 1 to myMsg.Recipient.Count do
        begin
           myMsg.Recipient.SetIndex(x-1);
           ListBox2.items.Add(myMsg.Recipient.DisplayName);
        end;
     ListBox3.clear;
     for x := 1 to myMsg.Attachment.Count do
        begin
           myMsg.Attachment.SetIndex(x-1);
           ListBox3.items.Add(myMsg.Attachment.FileName);
        end;
     end;
  myMsg.Destroy;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  ans : boolean;
begin
  ans := Mapi1.inbox.Load(true,false);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if Mapi1.QuickSend then
     Label3.caption := 'Successful QuickSend'
  else
     Label3.caption := 'QuickSend Failure';

end;

end.
